-- www.schwabenmodding.bplaced.net 
-- thanks to Desperados93 for some Ideas from the "schiebetor" LUA and also Giants Software for the "barriers" Script.

Fachwerkhaus = {};

  
local Fachwerkhaus_mt = Class(Fachwerkhaus);
function Fachwerkhaus.onCreate(id)
    g_currentMission:addUpdateable(Fachwerkhaus:new(id));
    print("Fachwerkhaus: Fachwerkhaus onCreate aufgerufen")	
end;
function Fachwerkhaus:new(id, customMt) 
    if customMt ~= nil then
        setmetatable(instance, customMt);
    else
        setmetatable(instance, Fachwerkhaus_mt);
    end;
    self.triggerId = id;
	addTrigger(id, "triggerCallback", self);
    self.deleteListenerId = addDeleteListener(id, "delete", self);
    self.openDoor = false;
    self.doorLeft = getChildAt(id, 0);
    self.doorRight = getChildAt(id, 1);
	
    self.rot = 0;
    self.maxRot = 100;
    self.minRot = 0;
    return instance;	
end;
  
function Fachwerkhaus:delete()
    removeTrigger(self.triggerId);
end;
  
function Fachwerkhaus:update(dt) 
    local old = self.rot;
    if self.openDoor == true then
	    if self.maxRot > self.minRot then
			if self.rot < self.maxRot then
				self.rot = self.rot + dt*0.001;    
			end;
		elseif self.maxRot < self.minRot then
			if self.rot > self.maxRot then
				self.rot = self.rot - dt*0.001;    
			end;		
		end;
    else
	    if self.maxRot > self.minRot then
			if self.rot > self.minRot then
				self.rot = self.rot - dt*0.001;    
			end;
		elseif self.maxRot < self.minRot then
			if self.rot < self.minRot then
				self.rot = self.rot + dt*0.001;    
			end;	
		end;	
    end;    
    if old ~= self.rot then
            setRotation(self.doorLeft, 0, self.rot, 0);
            setRotation(self.doorRight, 0, -self.rot, 0);			
    end; 
end;
  
function Fachwerkhaus:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay)
    if onEnter then
        self.openDoor = true;
	elseif onLeave then
        self.openDoor = false;
	end;
end;
    
g_onCreateUtil.addOnCreateFunction("FachwerkhausOnCreate", Fachwerkhaus.onCreate);

